Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 5093)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 5094)
@@ -15,4 +15,8 @@
 #  be useful, but WITHOUT ANY WARRANTY of any kind.
 
+ifndef VBOX_OSE
+VBOX_WITH_REGISTRATION := 1
+endif
+
 # include qmake project file
 include VBoxUI.pro
@@ -24,4 +28,9 @@
 # Import images
 VirtualBox_QT_IMAGES := $(IMAGES)
+
+# exclude inappropriate UI content
+ifndef VBOX_WITH_REGISTRATION
+VirtualBox_QT_UISRCS := $(filter-out ui/VBoxRegistrationDlg.ui,$(VirtualBox_QT_UISRCS))
+endif
 
 # reset things to avoid possible conflicts with kBuild
@@ -222,4 +231,7 @@
  VirtualBox_DEFS.linux   += VBOX_GUI_USE_QIMAGE
 endif
+ifdef VBOX_WITH_REGISTRATION
+ VirtualBox_DEFS         += VBOX_WITH_REGISTRATION
+endif
 ifdef VBOX_WITH_ALSA
  VirtualBox_DEFS         += VBOX_WITH_ALSA
@@ -229,5 +241,5 @@
 endif
 ifdef VBOX_WITH_DEBUGGER_GUI
-  VirtualBox_DEFS        += VBOX_WITH_DEBUGGER_GUI_MENU
+ VirtualBox_DEFS         += VBOX_WITH_DEBUGGER_GUI_MENU
 endif
 
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 5093)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 5094)
@@ -154,9 +154,9 @@
     static VBoxGlobal &instance();
 
-    bool isValid() { return valid; }
+    bool isValid() { return mValid; }
 
     QString versionString() { return verString; }
 
-    CVirtualBox virtualBox() const { return vbox; }
+    CVirtualBox virtualBox() const { return mVBox; }
 
     const VBoxGlobalSettings &settings() const { return gset; }
@@ -526,14 +526,16 @@
     void init();
 
-    bool valid;
-
-    CVirtualBox vbox;
+    bool mValid;
+
+    CVirtualBox mVBox;
 
     VBoxGlobalSettings gset;
 
-    VBoxSelectorWnd *selector_wnd;
-    VBoxConsoleWnd *console_wnd;
-
+    VBoxSelectorWnd *mSelectorWnd;
+    VBoxConsoleWnd *mConsoleWnd;
+
+#ifdef VBOX_WITH_REGISTRATION
     VBoxRegistrationDlg *mRegDlg;
+#endif
 
     QUuid vmUuid;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 5093)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 5094)
@@ -24,5 +24,8 @@
 #include "VBoxProblemReporter.h"
 #include "QIHotKeyEdit.h"
+
+#ifdef VBOX_WITH_REGISTRATION
 #include "VBoxRegistrationDlg.h"
+#endif
 
 #include <qapplication.h>
@@ -667,8 +670,10 @@
 
 VBoxGlobal::VBoxGlobal()
-    : valid (false)
-    , selector_wnd (0), console_wnd (0)
-    , mRegDlg (0)
-    , media_enum_thread (0)
+    : mValid (false)
+    , mSelectorWnd (NULL), mConsoleWnd (NULL)
+#ifdef VBOX_WITH_REGISTRATION
+    , mRegDlg (NULL)
+#endif
+    , media_enum_thread (NULL)
     , verString ("1.0")
     , vm_state_color (CEnums::MachineState_COUNT)
@@ -748,9 +753,9 @@
 bool VBoxGlobal::setSettings (const VBoxGlobalSettings &gs)
 {
-    gs.save (vbox);
-
-    if (!vbox.isOk())
-    {
-        vboxProblem().cannotSaveGlobalConfig (vbox);
+    gs.save (mVBox);
+
+    if (!mVBox.isOk())
+    {
+        vboxProblem().cannotSaveGlobalConfig (mVBox);
         return false;
     }
@@ -776,20 +781,20 @@
 #endif
 
-    Assert (valid);
-
-    if (!selector_wnd)
+    Assert (mValid);
+
+    if (!mSelectorWnd)
     {
         /*
-         *  We pass the address of selector_wnd to the constructor to let it be
+         *  We pass the address of mSelectorWnd to the constructor to let it be
          *  initialized right after the constructor is called. It is necessary
          *  to avoid recursion, since this method may be (and will be) called
          *  from the below constructor or from constructors/methods it calls.
          */
-        VBoxSelectorWnd *w = new VBoxSelectorWnd (&selector_wnd, 0, "selectorWnd");
-        Assert (w == selector_wnd);
+        VBoxSelectorWnd *w = new VBoxSelectorWnd (&mSelectorWnd, 0, "selectorWnd");
+        Assert (w == mSelectorWnd);
         NOREF(w);
     }
 
-    return *selector_wnd;
+    return *mSelectorWnd;
 }
 
@@ -807,20 +812,20 @@
 #endif
 
-    Assert (valid);
-
-    if (!console_wnd)
+    Assert (mValid);
+
+    if (!mConsoleWnd)
     {
         /*
-         *  We pass the address of console_wnd to the constructor to let it be
+         *  We pass the address of mConsoleWnd to the constructor to let it be
          *  initialized right after the constructor is called. It is necessary
          *  to avoid recursion, since this method may be (and will be) called
          *  from the below constructor or from constructors/methods it calls.
          */
-        VBoxConsoleWnd *w = new VBoxConsoleWnd (&console_wnd, 0, "consoleWnd");
-        Assert (w == console_wnd);
+        VBoxConsoleWnd *w = new VBoxConsoleWnd (&mConsoleWnd, 0, "consoleWnd");
+        Assert (w == mConsoleWnd);
         NOREF(w);
     }
 
-    return *console_wnd;
+    return *mConsoleWnd;
 }
 
@@ -1298,5 +1303,5 @@
         /* boot order */
         QString bootOrder;
-        for (ulong i = 1; i <= vbox.GetSystemProperties().GetMaxBootPosition(); i++)
+        for (ulong i = 1; i <= mVBox.GetSystemProperties().GetMaxBootPosition(); i++)
         {
             CEnums::DeviceType device = m.GetBootOrder (i);
@@ -1431,5 +1436,5 @@
         {
             item = QString::null;
-            ulong count = vbox.GetSystemProperties().GetNetworkAdapterCount();
+            ulong count = mVBox.GetSystemProperties().GetNetworkAdapterCount();
             int rows = 2; /* including section header and footer */
             for (ulong slot = 0; slot < count; slot ++)
@@ -1474,5 +1479,5 @@
         {
             item = QString::null;
-            ulong count = vbox.GetSystemProperties().GetSerialPortCount();
+            ulong count = mVBox.GetSystemProperties().GetSerialPortCount();
             int rows = 2; /* including section header and footer */
             for (ulong slot = 0; slot < count; slot ++)
@@ -1657,4 +1662,5 @@
 void VBoxGlobal::showRegistrationDialog()
 {
+#ifdef VBOX_WITH_REGISTRATION
     if (mRegDlg)
     {
@@ -1669,8 +1675,9 @@
         VBoxRegistrationDlg *dlg =
             new VBoxRegistrationDlg (0, 0, false, WDestructiveClose);
-        dlg->setup (&mRegDlg, "http://www.innotek.de/register762.php");
+        dlg->setup (&mRegDlg);
         Assert (dlg == mRegDlg);
         mRegDlg->show();
     }
+#endif
 }
 
@@ -1692,9 +1699,9 @@
     }
 
-    vbox.OpenSession (session, id);
-    if (!vbox.isOk())
-    {
-        CMachine machine = CVirtualBox (vbox).GetMachine (id);
-        vboxProblem().cannotOpenSession (vbox, machine);
+    mVBox.OpenSession (session, id);
+    if (!mVBox.isOk())
+    {
+        CMachine machine = CVirtualBox (mVBox).GetMachine (id);
+        vboxProblem().cannotOpenSession (mVBox, machine);
         session.detach();
     }
@@ -1708,5 +1715,5 @@
 bool VBoxGlobal::startMachine (const QUuid &id)
 {
-    AssertReturn (valid, false);
+    AssertReturn (mValid, false);
 
     CSession session = vboxGlobal().openSession (id);
@@ -1752,5 +1759,5 @@
 void VBoxGlobal::startEnumeratingMedia()
 {
-    Assert (valid);
+    Assert (mValid);
 
     /* check if already started but not yet finished */
@@ -1765,13 +1772,13 @@
     media_list.clear();
     {
-        CHardDiskEnumerator enHD = vbox.GetHardDisks().Enumerate();
+        CHardDiskEnumerator enHD = mVBox.GetHardDisks().Enumerate();
         while (enHD.HasMore())
             addMediaToList (media_list, CUnknown (enHD.GetNext()), VBoxDefs::HD);
 
-        CDVDImageEnumerator enCD = vbox.GetDVDImages().Enumerate();
+        CDVDImageEnumerator enCD = mVBox.GetDVDImages().Enumerate();
         while (enCD.HasMore())
             addMediaToList (media_list, CUnknown (enCD.GetNext()), VBoxDefs::CD);
 
-        CFloppyImageEnumerator enFD = vbox.GetFloppyImages().Enumerate();
+        CFloppyImageEnumerator enFD = mVBox.GetFloppyImages().Enumerate();
         while (enFD.HasMore())
             addMediaToList (media_list, CUnknown (enFD.GetNext()), VBoxDefs::FD);
@@ -1790,5 +1797,5 @@
             COMBase::initializeCOM();
 
-            CVirtualBox vbox = vboxGlobal().virtualBox();
+            CVirtualBox mVBox = vboxGlobal().virtualBox();
             QObject *target = &vboxGlobal();
 
@@ -1817,5 +1824,5 @@
                             if (!machineId.isNull())
                             {
-                                CMachine machine = vbox.GetMachine (machineId);
+                                CMachine machine = mVBox.GetMachine (machineId);
                                 if (!machine.isNull() && (machine.GetState() >= CEnums::Running))
                                     media.status = VBoxMedia::Ok;
@@ -3543,13 +3550,13 @@
 #endif
 
-    vbox.createInstance (CLSID_VirtualBox);
-    if (!vbox.isOk())
-    {
-        vboxProblem().cannotCreateVirtualBox (vbox);
+    mVBox.createInstance (CLSID_VirtualBox);
+    if (!mVBox.isOk())
+    {
+        vboxProblem().cannotCreateVirtualBox (mVBox);
         return;
     }
 
     // initialize guest OS type vector
-    CGuestOSTypeCollection coll = vbox.GetGuestOSTypes();
+    CGuestOSTypeCollection coll = mVBox.GetGuestOSTypes();
     int osTypeCount = coll.GetCount();
     AssertMsg (osTypeCount > 0, ("Number of OS types must not be zero"));
@@ -3650,8 +3657,8 @@
 
     // try to load global settings
-    gset.load (vbox);
-    if (!vbox.isOk() || !gset)
-    {
-        vboxProblem().cannotLoadGlobalConfig (vbox, gset.lastError());
+    gset.load (mVBox);
+    if (!mVBox.isOk() || !gset)
+    {
+        vboxProblem().cannotLoadGlobalConfig (mVBox, gset.lastError());
         return;
     }
@@ -3687,7 +3694,7 @@
                     vmUuid = uuid;
                 } else {
-                    CMachine m = vbox.FindMachine (param);
+                    CMachine m = mVBox.FindMachine (param);
                     if (m.isNull()) {
-                        vboxProblem().cannotFindMachineByName (vbox, param);
+                        vboxProblem().cannotFindMachineByName (mVBox, param);
                         return;
                     }
@@ -3724,7 +3731,7 @@
     // setup the callback
     callback = CVirtualBoxCallback (new VBoxCallback (*this));
-    vbox.RegisterCallback (callback);
-    AssertWrapperOk (vbox);
-    if (!vbox.isOk())
+    mVBox.RegisterCallback (callback);
+    AssertWrapperOk (mVBox);
+    if (!mVBox.isOk())
         return;
 
@@ -3738,5 +3745,5 @@
     QIconSet::setIconSize (QIconSet::Large, QSize (22, 22));
 
-    valid = true;
+    mValid = true;
 }
 
@@ -3757,6 +3764,6 @@
     if (!callback.isNull())
     {
-        vbox.UnregisterCallback (callback);
-        AssertWrapperOk (vbox);
+        mVBox.UnregisterCallback (callback);
+        AssertWrapperOk (mVBox);
         callback.detach();
     }
@@ -3770,10 +3777,13 @@
     }
 
-    if (console_wnd)
-        delete console_wnd;
-    if (selector_wnd)
-        delete selector_wnd;
+#ifdef VBOX_WITH_REGISTRATION
     if (mRegDlg)
         mRegDlg->close();
+#endif
+
+    if (mConsoleWnd)
+        delete mConsoleWnd;
+    if (mSelectorWnd)
+        delete mSelectorWnd;
 
     /* ensure CGuestOSType objects are no longer used */
@@ -3782,5 +3792,5 @@
     media_list.clear();
     /* the last step to ensure we don't use COM any more */
-    vbox.detach();
+    mVBox.detach();
 
     /* There may be VBoxEnumerateMediaEvent instances still in the message
@@ -3795,5 +3805,5 @@
 #endif
 
-    valid = false;
+    mValid = false;
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxProblemReporter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxProblemReporter.cpp	(revision 5093)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxProblemReporter.cpp	(revision 5094)
@@ -1435,6 +1435,6 @@
     aResult == "OK" ?
         message (aParent, Info,
-                 tr ("<p>Congratulations! You have successfully registered the "
-                     "VirtualBox product.</p>"
+                 tr ("<p>Congratulations! You have been successfully registered "
+                     "as a user of VirtualBox.</p>"
                      "<p>Thank you for finding time to fill out the "
                      "registration form!</p>")) :