Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 5194)
@@ -1197,5 +1197,4 @@
             vmStartAction->setMenuText (tr ("S&how"));
             vmStartAction->setText (tr ("Show"));
-            vmStartAction->setAccel (QString::null);
             vmStartAction->setStatusTip (
                 tr ("Switch to the window of the selected virtual machine"));
@@ -1207,5 +1206,4 @@
             vmStartAction->setMenuText (tr ("S&tart"));
             vmStartAction->setText (tr ("Start"));
-            vmStartAction->setAccel (QString::null);
             vmStartAction->setStatusTip (
                 tr ("Start the selected virtual machine"));
@@ -1273,5 +1271,4 @@
         vmStartAction->setMenuText (tr ("S&tart"));
         vmStartAction->setText (tr ("Start"));
-        vmStartAction->setAccel (QString::null);
         vmStartAction->setStatusTip (
             tr ("Start the selected virtual machine"));
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui	(revision 5194)
@@ -362,7 +362,4 @@
                             <property name="text">
                                 <string>&amp;OK</string>
-                            </property>
-                            <property name="accel">
-                                <string>Alt+O</string>
                             </property>
                             <property name="autoDefault">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxGlobalSettingsDlg.ui	(revision 5194)
@@ -477,7 +477,4 @@
                                     <string>Enable &amp;VT-x/AMD-V</string>
                                 </property>
-                                <property name="accel">
-                                    <string>Alt+V</string>
-                                </property>
                                 <property name="whatsThis" stdset="0">
                                     <string>Defines whether virtual machines should try to make use of the host CPU's hardware virtualization extensions such as Intel VT-x and AMD-V by default or not.</string>
@@ -581,7 +578,4 @@
                                 <property name="text">
                                     <string>&amp;Auto capture keyboard</string>
-                                </property>
-                                <property name="accel">
-                                    <string>Alt+A</string>
                                 </property>
                                 <property name="whatsThis" stdset="0">
@@ -1136,7 +1130,4 @@
                     <property name="text">
                         <string>&amp;OK</string>
-                    </property>
-                    <property name="accel">
-                        <string>Alt+O</string>
                     </property>
                     <property name="autoDefault">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui	(revision 5194)
@@ -232,7 +232,4 @@
                                     <string>&amp;Dynamically expanding image</string>
                                 </property>
-                                <property name="accel">
-                                    <string>Alt+D</string>
-                                </property>
                                 <property name="checked">
                                     <bool>true</bool>
@@ -245,7 +242,4 @@
                                 <property name="text">
                                     <string>&amp;Fixed-size image</string>
-                                </property>
-                                <property name="accel">
-                                    <string>Alt+F</string>
                                 </property>
                             </widget>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxSnapshotDetailsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxSnapshotDetailsDlg.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxSnapshotDetailsDlg.ui	(revision 5194)
@@ -221,7 +221,4 @@
                     <property name="text">
                         <string>&amp;OK</string>
-                    </property>
-                    <property name="accel">
-                        <string>Alt+O</string>
                     </property>
                     <property name="autoDefault">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui	(revision 5194)
@@ -236,7 +236,4 @@
                     <property name="text">
                         <string>&amp;OK</string>
-                    </property>
-                    <property name="accel">
-                        <string>Alt+O</string>
                     </property>
                     <property name="autoDefault">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMFirstRunWzd.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMFirstRunWzd.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMFirstRunWzd.ui	(revision 5194)
@@ -267,7 +267,4 @@
                                     <string>&amp;CD/DVD-ROM Device</string>
                                 </property>
-                                <property name="accel">
-                                    <string>Alt+C</string>
-                                </property>
                                 <property name="checked">
                                     <bool>false</bool>
@@ -283,7 +280,4 @@
                                 <property name="text">
                                     <string>&amp;Floppy Device</string>
-                                </property>
-                                <property name="accel">
-                                    <string>Alt+F</string>
                                 </property>
                             </widget>
@@ -357,7 +351,4 @@
                                             <string>&amp;Host Drive</string>
                                         </property>
-                                        <property name="accel">
-                                            <string>Alt+H</string>
-                                        </property>
                                         <property name="checked">
                                             <bool>false</bool>
@@ -413,7 +404,4 @@
                                         <property name="text">
                                             <string>&amp;Image File</string>
-                                        </property>
-                                        <property name="accel">
-                                            <string>Alt+I</string>
                                         </property>
                                     </widget>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMLogViewer.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMLogViewer.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMLogViewer.ui	(revision 5194)
@@ -94,7 +94,4 @@
                         <string>&amp;Find</string>
                     </property>
-                    <property name="accel">
-                        <string>Alt+F</string>
-                    </property>
                 </widget>
                 <widget class="QPushButton">
@@ -104,7 +101,4 @@
                     <property name="text">
                         <string>&amp;Save</string>
-                    </property>
-                    <property name="accel">
-                        <string>Alt+S</string>
                     </property>
                     <property name="autoDefault">
@@ -121,7 +115,4 @@
                     <property name="text">
                         <string>&amp;Refresh</string>
-                    </property>
-                    <property name="accel">
-                        <string>Alt+R</string>
                     </property>
                 </widget>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMLogViewer.ui.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMLogViewer.ui.h	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMLogViewer.ui.h	(revision 5194)
@@ -120,18 +120,23 @@
     void languageChange()
     {
+        QKeySequence accel;
+
         QToolTip::add (mButtonClose, tr ("Close the search panel"));
+
         mSearchName->setText (tr ("Find "));
         QToolTip::add (mSearchString, tr ("Enter a search string here"));
-        mButtonPrev->setTextLabel (tr ("&Previous"));
-        mButtonPrev->setAccel (QKeySequence (tr ("Alt+P")));
+
+        VBoxGlobal::setTextLabel (mButtonPrev, tr ("&Previous"));
         QToolTip::add (mButtonPrev,
             tr ("Search for the previous occurrence of the string"));
-        mButtonNext->setTextLabel (tr ("&Next"));
-        mButtonNext->setAccel (QKeySequence (tr ("Alt+N")));
+
+        VBoxGlobal::setTextLabel (mButtonNext, tr ("&Next"));
         QToolTip::add (mButtonNext,
             tr ("Search for the next occurrence of the string"));
+
         mCaseSensitive->setText (tr ("C&ase Sensitive"));
         QToolTip::add (mCaseSensitive,
             tr ("Perform case sensitive search (when checked)"));
+
         mWarningString->setText (tr ("String not found"));
     }
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui	(revision 5194)
@@ -145,7 +145,4 @@
                                 <string>&amp;Generate</string>
                             </property>
-                            <property name="accel">
-                                <string>Alt+G</string>
-                            </property>
                             <property name="whatsThis" stdset="0">
                                 <string>Generates a new random MAC address.</string>
@@ -206,7 +203,4 @@
                     <property name="text">
                         <string>Ca&amp;ble Connected</string>
-                    </property>
-                    <property name="accel">
-                        <string>Alt+B</string>
                     </property>
                     <property name="whatsThis" stdset="0">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSerialPortSettings.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSerialPortSettings.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSerialPortSettings.ui	(revision 5194)
@@ -168,7 +168,4 @@
                             <property name="text">
                                 <string>&amp;Create Pipe</string>
-                            </property>
-                            <property name="accel">
-                                <string>Alt+C</string>
                             </property>
                             <property name="whatsThis" stdset="0">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 5193)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 5194)
@@ -1055,7 +1055,4 @@
                                                         <string>Enable A&amp;CPI</string>
                                                     </property>
-                                                    <property name="accel">
-                                                        <string>Alt+C</string>
-                                                    </property>
                                                     <property name="whatsThis" stdset="0">
                                                         <string>&lt;qt&gt;When checked, the virtual machine will support
@@ -1071,7 +1068,4 @@
                                                         <string>Enable IO A&amp;PIC</string>
                                                     </property>
-                                                    <property name="accel">
-                                                        <string>Alt+P</string>
-                                                    </property>
                                                     <property name="whatsThis" stdset="0">
                                                         <string>&lt;qt&gt;When checked, the virtual machine will support
@@ -1086,7 +1080,4 @@
                                                     <property name="text">
                                                         <string>Enable &amp;VT-x/AMD-V</string>
-                                                    </property>
-                                                    <property name="accel">
-                                                        <string>Alt+V</string>
                                                     </property>
                                                     <property name="tristate">
@@ -1294,7 +1285,4 @@
                                             <property name="text">
                                                 <string>&amp;Remember Media Mounted at Runtime</string>
-                                            </property>
-                                            <property name="accel">
-                                                <string>Alt+R</string>
                                             </property>
                                             <property name="checked">
@@ -1582,7 +1570,4 @@
                                             <string>Host CD/DVD &amp;Drive</string>
                                         </property>
-                                        <property name="accel">
-                                            <string>Alt+D</string>
-                                        </property>
                                         <property name="whatsThis" stdset="0">
                                             <string>Mounts the specified CD/DVD drive to the virtual CD/DVD drive.</string>
@@ -1659,7 +1644,4 @@
                                             <string>&amp;Enable Passthrough</string>
                                         </property>
-                                        <property name="accel">
-                                            <string>Alt+E</string>
-                                        </property>
                                         <property name="whatsThis" stdset="0">
                                             <string>When checked, allows the guest to send ATAPI commands directly to the host drive which makes it possible to use CD/DVD writers connected to the host inside the VM. Note that writing audio CD inside the VM is not yet supported.</string>
@@ -1682,7 +1664,4 @@
                                         <property name="text">
                                             <string>&amp;ISO Image File</string>
-                                        </property>
-                                        <property name="accel">
-                                            <string>Alt+I</string>
                                         </property>
                                         <property name="whatsThis" stdset="0">
@@ -1839,7 +1818,4 @@
                                             <string>Host Floppy &amp;Drive</string>
                                         </property>
-                                        <property name="accel">
-                                            <string>Alt+D</string>
-                                        </property>
                                         <property name="whatsThis" stdset="0">
                                             <string>Mounts the specified host Floppy drive to the virtual Floppy drive.</string>
@@ -1887,7 +1863,4 @@
                                         <property name="text">
                                             <string>&amp;Image File</string>
-                                        </property>
-                                        <property name="accel">
-                                            <string>Alt+I</string>
                                         </property>
                                         <property name="whatsThis" stdset="0">
@@ -2265,7 +2238,4 @@
                         <property name="text">
                             <string>Enable &amp;USB Controller</string>
-                        </property>
-                        <property name="accel">
-                            <string>Alt+U</string>
                         </property>
                         <property name="whatsThis" stdset="0">
@@ -2856,7 +2826,4 @@
                     <property name="text">
                         <string>&amp;OK</string>
-                    </property>
-                    <property name="accel">
-                        <string>Alt+O</string>
                     </property>
                     <property name="autoDefault">