Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 5245)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 5246)
@@ -375,5 +375,5 @@
     <message>
         <source>&amp;Make Permanent</source>
-        <translation type="unfinished"></translation>
+        <translation>&amp;Permanent erzeugen</translation>
     </message>
 </context>
@@ -393,22 +393,10 @@
     </message>
     <message>
-        <source>Alt+S</source>
-        <translation type="obsolete">Alt+S</translation>
-    </message>
-    <message>
         <source>&amp;Power off the machine</source>
         <translation>die virtuelle Maschine &amp;ausschalten</translation>
     </message>
     <message>
-        <source>Alt+P</source>
-        <translation type="obsolete">Alt+A</translation>
-    </message>
-    <message>
         <source>&amp;Revert to the current snapshot</source>
         <translation>&amp;Zurückkehren zum letzten Sicherungspunkt</translation>
-    </message>
-    <message>
-        <source>Alt+R</source>
-        <translation type="obsolete">Alt+Z</translation>
     </message>
     <message>
@@ -947,8 +935,4 @@
     </message>
     <message>
-        <source>Alt+O</source>
-        <translation type="obsolete">Alt+O</translation>
-    </message>
-    <message>
         <source>Accept dialog</source>
         <translation>Änderungen übernehmen</translation>
@@ -1181,16 +1165,4 @@
     </message>
     <message>
-        <source>Could not determine the file size.</source>
-        <translation type="obsolete">Die Dateigröße konnte nicht ermittelt werden.</translation>
-    </message>
-    <message>
-        <source>Could not connect to the server (%1).</source>
-        <translation type="obsolete">Eine Verbindung zum Server konnte nicht hergestellt werden (%1).</translation>
-    </message>
-    <message>
-        <source>Could not download the file (%1).</source>
-        <translation type="obsolete">Die Datei konnte nicht heruntergeladen werden (%1).</translation>
-    </message>
-    <message>
         <source>&lt;p&gt;Failed to save the downloaded file as &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;</source>
         <translation>&lt;p&gt;Die heruntergeladene Datei konnte nicht als &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt; gespeichert werden.&lt;/nobr&gt;&lt;/p&gt;</translation>
@@ -1965,8 +1937,4 @@
         <source>&amp;OK</source>
         <translation>&amp;OK</translation>
-    </message>
-    <message>
-        <source>Alt+O</source>
-        <translation type="obsolete">Alt+O</translation>
     </message>
     <message>
@@ -2116,8 +2084,4 @@
     </message>
     <message>
-        <source>Alt+V</source>
-        <translation type="obsolete">Alt+V</translation>
-    </message>
-    <message>
         <source>Defines whether virtual machines should try to make use of the host CPU&apos;s hardware virtualization extensions such as Intel VT-x and AMD-V by default or not.</source>
         <translation>Zeigt, ob virtuelle Maschinen einen speziellen Modus der CPU für die Virtualisierung (Intel VT-x bzw. AMD-V) per Voreinstellung nutzen sollen oder nicht.</translation>
@@ -2154,8 +2118,4 @@
     </message>
     <message>
-        <source>Alt+P</source>
-        <translation type="obsolete">Alt+R</translation>
-    </message>
-    <message>
         <source>Search for the previous occurrence of the string</source>
         <translation>Durchsucht den Text rückwärts</translation>
@@ -2164,8 +2124,4 @@
         <source>&amp;Next</source>
         <translation>&amp;Vorwärts</translation>
-    </message>
-    <message>
-        <source>Alt+N</source>
-        <translation type="obsolete">Alt+V</translation>
     </message>
     <message>
@@ -3276,8 +3232,4 @@
     </message>
     <message>
-        <source>Alt+O</source>
-        <translation type="obsolete">Alt+O</translation>
-    </message>
-    <message>
         <source>Cancel</source>
         <translation>Abbrechen</translation>
@@ -3479,8 +3431,4 @@
         <source>&amp;OK</source>
         <translation>&amp;OK</translation>
-    </message>
-    <message>
-        <source>Alt+O</source>
-        <translation type="obsolete">Alt+O</translation>
     </message>
     <message>
@@ -3686,8 +3634,4 @@
     </message>
     <message>
-        <source>Alt+F</source>
-        <translation type="obsolete">Alt+D</translation>
-    </message>
-    <message>
         <source>&lt;p&gt;Select the media which contains the setup program of the operating system you want to install. This media must be bootable, otherwise the setup program will not be able to start.&lt;/p&gt;</source>
         <translation>&lt;p&gt;Wählen Sie das Medium mit dem Installationsprogramm des Betriebssystems, das Sie installieren wollen. Dieses Medium muss bootbar sein, anderenfalls kann das Installationsprogramm nicht starten.&lt;/p&gt;</translation>
@@ -3702,14 +3646,6 @@
     </message>
     <message>
-        <source>Alt+H</source>
-        <translation type="obsolete">Alt+H</translation>
-    </message>
-    <message>
         <source>&amp;Image File</source>
         <translation>&amp;Abbild</translation>
-    </message>
-    <message>
-        <source>Alt+I</source>
-        <translation type="obsolete">Alt+A</translation>
     </message>
     <message>
@@ -3798,16 +3734,8 @@
     </message>
     <message>
-        <source>Alt+S</source>
-        <translation type="obsolete">Alt+S</translation>
-    </message>
-    <message>
         <source>&amp;Refresh</source>
         <translation>&amp;Aktualisieren</translation>
     </message>
     <message>
-        <source>Alt+R</source>
-        <translation type="obsolete">Alt+A</translation>
-    </message>
-    <message>
         <source>%1 - VirtualBox Log Viewer</source>
         <translation>%1 - VirtualBox Log-Anzeige</translation>
@@ -3832,8 +3760,4 @@
         <source>&amp;Find</source>
         <translation>&amp;Suche</translation>
-    </message>
-    <message>
-        <source>Alt+F</source>
-        <translation type="obsolete">Alt+S</translation>
     </message>
     <message>
@@ -3861,16 +3785,8 @@
     </message>
     <message>
-        <source>Alt+G</source>
-        <translation type="obsolete">Alt+G</translation>
-    </message>
-    <message>
         <source>Ca&amp;ble Connected</source>
         <translation>Netzwerk&amp;kabel angeschlossen</translation>
     </message>
     <message>
-        <source>Alt+B</source>
-        <translation type="obsolete">Alt+K</translation>
-    </message>
-    <message>
         <source>Host Interface Settings</source>
         <translation>Einstellungen für Hostinterface</translation>
@@ -3919,8 +3835,4 @@
         <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Legt fest, wie dieser virtuelle Netzwerk-Adapter an das physische Netzwerk des Host-BS angeschlossen ist.</translation>
-    </message>
-    <message>
-        <source>Displays the MAC address of this adapter. It contains exactly 12 characters chosen from {0-9,A-F}.</source>
-        <translation type="obsolete">Zeigt die MAC-Adresse dieses Adapters. Sie besteht aus exakt 12 Zeichen aus dem Zeichenvorrat {0-9,A-F}.</translation>
     </message>
     <message>
@@ -4008,8 +3920,4 @@
     </message>
     <message>
-        <source>Alt+C</source>
-        <translation type="obsolete">Alt+P</translation>
-    </message>
-    <message>
         <source>If checked, the pipe specified in the &lt;b&gt;Port Path&lt;/b&gt; field will be created by the virtual machine when it starts. Otherwise, the virtual machine will try to use the existing pipe.</source>
         <translation>Wenn diese Box ausgewählt wurde, dann wird die Pipe im &lt;b&gt;Portpfad&lt;/b&gt; von der virtuellen Maschine erzeugt, wenn diese startet. Anderenfalls versucht die virtuelle Maschine, sich an eine vorhandene Pipe zu anzuschließen.</translation>
@@ -4235,8 +4143,4 @@
     </message>
     <message>
-        <source>Alt+P</source>
-        <translation type="obsolete">Alt+I</translation>
-    </message>
-    <message>
         <source>Boo&amp;t Order</source>
         <translation>Boo&amp;t-Reihenfolge</translation>
@@ -4283,8 +4187,4 @@
     </message>
     <message>
-        <source>Alt+I</source>
-        <translation type="obsolete">Alt+A</translation>
-    </message>
-    <message>
         <source>Mounts the specified Floppy image to the virtual Floppy drive.</source>
         <translation>Verbindet das eingestellte Diskettenlaufwerk mit der virtuellen Maschine.</translation>
@@ -4409,8 +4309,4 @@
         <source>&amp;OK</source>
         <translation>&amp;OK</translation>
-    </message>
-    <message>
-        <source>Alt+O</source>
-        <translation type="obsolete">Alt+O</translation>
     </message>
     <message>
@@ -4635,8 +4531,4 @@
     </message>
     <message>
-        <source>Alt+R</source>
-        <translation type="obsolete">Alt+M</translation>
-    </message>
-    <message>
         <source>If checked, any change to mounted CD/DVD or Floppy media performed during machine execution will be saved in the settings file in order to preserve the configuration of mounted media between runs.</source>
         <translation>Falls ausgewählt, werden zur Laufzeit zugewiesene CD/DVD- oder Diskettenmedien in den Einstellungen gespeichert um die Zuweisung über die Laufzeit der VM hinaus beizubehalten.</translation>
@@ -4649,8 +4541,4 @@
         <source>&amp;Enable Passthrough</source>
         <translation>&amp;Passthrough aktivieren</translation>
-    </message>
-    <message>
-        <source>Alt+E</source>
-        <translation type="obsolete">Alt+P</translation>
     </message>
     <message>