Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 5327)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 5370)
@@ -6,5 +6,5 @@
 
      Copyright (C) 2006-2007 innotek GmbH
-    
+
      This file is part of VirtualBox Open Source Edition (OSE), as
      available from http://www.virtualbox.org. This file is free software;
@@ -1092,10 +1092,7 @@
                                     </hbox>
                                 </widget>
-                                <widget class="QGroupBox">
+                                <widget class="QLayoutWidget">
                                     <property name="name">
-                                        <cstring>groupBox61</cstring>
-                                    </property>
-                                    <property name="title">
-                                        <string>&amp;Shared Clipboard</string>
+                                        <cstring>layout102</cstring>
                                     </property>
                                     <hbox>
@@ -1103,37 +1100,96 @@
                                             <cstring>unnamed</cstring>
                                         </property>
-                                        <widget class="QComboBox">
+                                        <widget class="QGroupBox">
                                             <property name="name">
-                                                <cstring>cbSharedClipboard</cstring>
-                                            </property>
-                                            <property name="whatsThis" stdset="0">
-                                                <string>Defines the mode of sharing the clipboard between the guest and the host OS. Note that this feature requires Guest Additions to be installed in the guest OS.</string>
-                                            </property>
-                                            <property name="sizePolicy">
-                                                <sizepolicy>
-                                                    <hsizetype>5</hsizetype>
-                                                    <vsizetype>0</vsizetype>
-                                                    <horstretch>0</horstretch>
-                                                    <verstretch>0</verstretch>
-                                                </sizepolicy>
-                                            </property>
+                                                <cstring>groupBox61</cstring>
+                                            </property>
+                                            <property name="title">
+                                                <string>&amp;Shared Clipboard</string>
+                                            </property>
+                                            <hbox>
+                                                <property name="name">
+                                                    <cstring>unnamed</cstring>
+                                                </property>
+                                                <widget class="QComboBox">
+                                                    <property name="name">
+                                                        <cstring>cbSharedClipboard</cstring>
+                                                    </property>
+                                                    <property name="sizePolicy">
+                                                        <sizepolicy>
+                                                            <hsizetype>5</hsizetype>
+                                                            <vsizetype>0</vsizetype>
+                                                            <horstretch>0</horstretch>
+                                                            <verstretch>0</verstretch>
+                                                        </sizepolicy>
+                                                    </property>
+                                                    <property name="whatsThis" stdset="0">
+                                                        <string>Defines the mode of sharing the clipboard between the guest and the host OS. Note that this feature requires Guest Additions to be installed in the guest OS.</string>
+                                                    </property>
+                                                </widget>
+                                                <spacer>
+                                                    <property name="name">
+                                                        <cstring>spacer130</cstring>
+                                                    </property>
+                                                    <property name="orientation">
+                                                        <enum>Horizontal</enum>
+                                                    </property>
+                                                    <property name="sizeType">
+                                                        <enum>Expanding</enum>
+                                                    </property>
+                                                    <property name="sizeHint">
+                                                        <size>
+                                                            <width>0</width>
+                                                            <height>20</height>
+                                                        </size>
+                                                    </property>
+                                                </spacer>
+                                            </hbox>
                                         </widget>
-                                        <spacer>
+                                        <widget class="QGroupBox">
                                             <property name="name">
-                                                <cstring>spacer130</cstring>
-                                            </property>
-                                            <property name="orientation">
-                                                <enum>Horizontal</enum>
-                                            </property>
-                                            <property name="sizeType">
-                                                <enum>Expanding</enum>
-                                            </property>
-                                            <property name="sizeHint">
-                                                <size>
-                                                    <width>0</width>
-                                                    <height>20</height>
-                                                </size>
-                                            </property>
-                                        </spacer>
+                                                <cstring>groupBox62</cstring>
+                                            </property>
+                                            <property name="title">
+                                                <string>&amp;IDE Controller Type</string>
+                                            </property>
+                                            <hbox>
+                                                <property name="name">
+                                                    <cstring>unnamed</cstring>
+                                                </property>
+                                                <widget class="QComboBox">
+                                                    <property name="name">
+                                                        <cstring>cbIdeController</cstring>
+                                                    </property>
+                                                    <property name="sizePolicy">
+                                                        <sizepolicy>
+                                                            <hsizetype>5</hsizetype>
+                                                            <vsizetype>0</vsizetype>
+                                                            <horstretch>0</horstretch>
+                                                            <verstretch>0</verstretch>
+                                                        </sizepolicy>
+                                                    </property>
+                                                    <property name="whatsThis" stdset="0">
+                                                        <string>Defines the type of the virtual IDE controller. Depending on this value, VirtualBox will provide different virtual IDE hardware devices to the guest OS.</string>
+                                                    </property>
+                                                </widget>
+                                                <spacer>
+                                                    <property name="name">
+                                                        <cstring>spacer131</cstring>
+                                                    </property>
+                                                    <property name="orientation">
+                                                        <enum>Horizontal</enum>
+                                                    </property>
+                                                    <property name="sizeType">
+                                                        <enum>Expanding</enum>
+                                                    </property>
+                                                    <property name="sizeHint">
+                                                        <size>
+                                                            <width>0</width>
+                                                            <height>20</height>
+                                                        </size>
+                                                    </property>
+                                                </spacer>
+                                            </hbox>
+                                        </widget>
                                     </hbox>
                                 </widget>
@@ -2984,4 +3040,5 @@
     <tabstop>chbVTX</tabstop>
     <tabstop>cbSharedClipboard</tabstop>
+    <tabstop>cbIdeController</tabstop>
     <tabstop>leSnapshotFolder</tabstop>
     <tabstop>tbSelectSavedStateFolder</tabstop>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h	(revision 5327)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h	(revision 5370)
@@ -835,4 +835,7 @@
     cbSharedClipboard->insertItem (vboxGlobal().toString (CEnums::ClipGuestToHost));
     cbSharedClipboard->insertItem (vboxGlobal().toString (CEnums::ClipBidirectional));
+    /* IDE Controller Type */
+    cbIdeController->insertItem (vboxGlobal().toString (CEnums::IDEControllerPIIX3));
+    cbIdeController->insertItem (vboxGlobal().toString (CEnums::IDEControllerPIIX4));
 
     /* HDD Images page */
@@ -877,5 +880,5 @@
 }
 
-/** 
+/**
  *  Returns a path to the given page of this settings dialog. See ::path() for
  *  details.
@@ -1584,4 +1587,7 @@
     /* Shared clipboard mode */
     cbSharedClipboard->setCurrentItem (machine.GetClipboardMode());
+
+    /* IDE controller type */
+    cbIdeController->setCurrentText (vboxGlobal().toString (biosSettings.GetIDEControllerType()));
 
     /* other features */
@@ -1944,4 +1950,7 @@
     cmachine.SetClipboardMode ((CEnums::ClipboardMode)cbSharedClipboard->currentItem());
 
+    /* IDE controller type */
+    biosSettings.SetIDEControllerType (vboxGlobal().toIDEControllerType (cbIdeController->currentText()));
+
     /* other features */
     cmachine.SetExtraData (VBoxDefs::GUI_SaveMountedAtRuntime,